//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Main.h"
#include "DirEx.h" // Funkce CreateSubDirectory(...)
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TInstallForm *InstallForm;
//---------------------------------------------------------------------------
__fastcall TInstallForm::TInstallForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TInstallForm::FormCreate(TObject *Sender)
{
  // Pomocne promenne
  CHAR lpWinDir[MAXPATH];                             // Adresar windows, z nej zjistime startovni disk
  CHAR lpStandartPath[] = "X:\\Program Files\\Vtipy"; // Standartni Edit1->Text
  CHAR lpStandartDir[] = "X:\\";                      // Standartni DirectroyListBox1->Directory

  // Zjistime adresar Windows a z nej pozdeji standartni pismeno disku
  GetWindowsDirectoryA(lpWinDir, MAXPATH);

  // Nastaveni hodnot
  lpStandartDir[0] = lpStandartPath[0] = DriveComboBox1->Drive = lpWinDir[0];
  dwItemIndex = DriveComboBox1->ItemIndex; // Ulozeni indexu pocatecniho disku
  DirectoryListBox1->Directory = lpStandartDir;
  Edit1->Text = lpStandartPath;
}
//---------------------------------------------------------------------------
void __fastcall TInstallForm::DirectoryListBox1Change(TObject *Sender)
{
  // Nejdrive kontrola, jestli delka nazvu ciloveho adresare neprekracuje
  // maximalni velikost (128 znaku v nasem pripade)
  if(DirectoryListBox1->Directory.Length() <= 128)
  {
    // Predani adresare do Edit1
    if(DirectoryListBox1->Directory.Length() > 3)
      // Napr.: "C:\Program Files" + "\Vtipy"
      Edit1->Text = DirectoryListBox1->Directory + "\\Vtipy";
    else
      // Napr.: "C:\" + "Vtipy"
      Edit1->Text = DirectoryListBox1->Directory + "Vtipy";
  }
}
//---------------------------------------------------------------------------
void __fastcall TInstallForm::StornoButtonClick(TObject *Sender)
{
  // Tlacitko Storno uonci program
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TInstallForm::DriveComboBox1Click(TObject *Sender)
{
  // Toto cele delame proto, aby se pri zvoleni nepritomneho disku
  // (treba FDD, CD, ...) v DriveComboBoxu neobjevila zprava
  // 'I/O Error 21', misto toho se otevre implicitni disk.

  // Pomocne promenne
  CHAR lpTestDir[] = "X:\\"; // Pro testovani pritomnosti daneho disku
  CHAR lpDir[MAXPATH];       // Pro ulozeni cesty

  // Ulozime aktualni cestu
  GetCurrentDirectoryA(MAXPATH, lpDir);
  // Zjistime, na ktery disk uzivatel prepnul
  lpTestDir[0] = DriveComboBox1->Items->Strings[DriveComboBox1->ItemIndex].c_str()[0];
  // Test, zda lze disk otevrit, jestli disk chybi, tak otereme ten pocatecni.
  if(!SetCurrentDirectoryA(lpTestDir))
    DriveComboBox1->ItemIndex = dwItemIndex;
  // Obnovime puvodni cestu
  SetCurrentDirectoryA(lpDir);
}
//---------------------------------------------------------------------------
void __fastcall TInstallForm::OKButtonClick(TObject *Sender)
{
  // Vytvorime adresar pro instalaci
  if(!CreateSubDirectory(InstallForm->Edit1->Text.c_str(), NULL))
  {
    // Adresar se nepodarilo vytvorit, tak to oznamime uzivateli
    MessageBeep(MB_ICONEXCLAMATION);
    MessageBoxA(Handle, "Nelze vytvoit Vmi zvolen adres.",
               "Chyba...", MB_OK | MB_APPLMODAL | MB_ICONEXCLAMATION);
  }
  else
  {
    // Nastavime polohu okna tak, aby tlacitka 'Dalsi >' a 'Dokoncit'
    // meli stejnou polohu - Good efect.
    InfoForm->Left = Left - 128;
    InfoForm->Top  = Top  + 48;

    // Zobrazeni dalsi formy
    InfoForm->Show();
    Hide();
  }
}
//---------------------------------------------------------------------------
