//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Progress.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TProgressForm *ProgressForm;
//---------------------------------------------------------------------------
__fastcall TProgressForm::TProgressForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TProgressForm::CreateParams(Controls::TCreateParams &Param)
{
  TForm::CreateParams(Param);
  Param.Style = WS_POPUP | WS_BORDER; // Okno bude bez titulkoveho pruhu
                                      // a systemoveho menu.
}
//---------------------------------------------------------------------------
void __fastcall TProgressForm::FormActivate(TObject *Sender)
{
  // Inicializace kriticke sekce
  InitializeCriticalSection(&CritSec);

  // Inicializace promennych, kriticke sekce jeste nemusime pouzivat,
  // thread totiz zatim neexistuje.
  ZeroMemory(lpInfoString, sizeof(lpInfoString));
  dwPercent = dwStop = 0;
  dwThreadId = NULL;
  strcpy(lpInstallDir, InstallForm->Edit1->Text.c_str());
  fCreateShortcut = (InfoForm->ShortcutCheckBox->Checked && InfoForm->ShortcutCheckBox->Enabled);

  // Spusteni Progress-Threadu.
  hThread = chBEGINTHREADEX(NULL, 0, ProgressThreadFunction, NULL, 0, &dwThreadId);
  if(!hThread) // Pokud nastala chyba, oznamime to a zavreme ProgressForm
  {
    MessageBeep(MB_ICONSTOP);
    MessageBoxA(Handle, "V aplikaci  dolo  k neoekvan  vyjmce.  Vypnte\n"
                        "prosm vechny ostatn programy a spuste instalaci\n"
                        "znovu, pote by se ji nemly opakovat.\n",
                "Chyba...", MB_OK | MB_APPLMODAL | MB_ICONSTOP);
    Close(); // Konec
  }

  // Spustime timer
  Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TProgressForm::CancelButtonClick(TObject *Sender)
{
  // Zastavime thread
  SuspendThread(hThread);

  // Zeptame se uzivatele, jestli chce fakt skoncit
  MessageBeep(MB_ICONQUESTION);
  if(MessageBoxA(Handle, "Peruenm  procesu  mohou  na  disku  zstat  nepotebn  soubory\n"
                         "a v registru nkter hodnoty. Opravdu si pejete ukonit instalaci ?",
                 "Potvrte konec...", MB_YESNO | MB_APPLMODAL | MB_DEFBUTTON2 | MB_ICONQUESTION) == IDYES)
    Close(); // Konec, thread je furt zastaven

  // Znovu spustime thread, instalace bude pokracovat
  ResumeThread(hThread);
}
//---------------------------------------------------------------------------
void __fastcall TProgressForm::Timer1Timer(TObject *Sender)
{
  // Casovac ma takt 275 ms (5 x 55 ms - interni casove kvantum WIN32)

  // Promenne
  DWORD     dwStopShadow;   // Stin promenne dwStop

  // Obmenime zobrazovane informace - pouzivame kriticke sekce,
  // protoze dane promenne pouziva i progress-thread.
  EnterCriticalSection(&CritSec);
  dwStopShadow = dwStop;                    // Zjisteni hodnoty dwStop
  ProgressBar1->Position = (WORD)dwPercent; // Nacteni procent
  Label1->Caption = lpInfoString;           // Nacteni labelu
  LeaveCriticalSection(&CritSec);

  // Jeste mala uprava labelu s procentama
  Label3->Caption = AnsiString(ProgressBar1->Position) + AnsiString(" %");

  // Nedokoncil uz thread praci (chyba, nebo uz hotovo)
  if(dwStopShadow)
  {
    // Vypneme timer a zavreme formu
    Timer1->Enabled = false;
    Close();
  }
}
//---------------------------------------------------------------------------
void __fastcall TProgressForm::FormClose(TObject *Sender, TCloseAction &Action)
{
  // Promenne
  DWORD     dwStopShadow;   // Stin promenne dwStop
  CHAR      lpText[512];    // Text pro uzivatele do MessageBoxu

  // Skryjeme formu, aby nebyla videt
  Hide();

  // Vypneme casovac, pokud jeste nahodou neni vypnut
  Timer1->Enabled = false;

  // Pokud existuje thread, musime ho taky nejak ukoncit
  if(hThread)
  {
    // Pokud byl thread zastaven, znovu ho spustime, jinak by mohlo dojit
    // k zatuhnuti aplikace, nebo by se thread nemohl sam ukoncit.
    ResumeThread(hThread);

    // Pokud thread jeste bezi (dwStop == 0), tak ho informujeme, ze se
    // ma vypnout. Hodnotu dwStop si ulozime do dwStopShadow.
    EnterCriticalSection(&CritSec);
    if(dwStop == 0)
      dwStop = 2; // Preruseni z venku
    dwStopShadow = dwStop; // Ulozeni hodnoty dwStop
    LeaveCriticalSection(&CritSec);

    // Vyhodnoceni dwStop
    switch(dwStopShadow)
    {
      case 1:  // Instalace uz je normalne hotova
               // Ale i presto si nyni pockame, az se thread ukonci, muze
               // totiz jeste bezet.
               WaitForSingleObject(hThread, INFINITE);
               // Zprava uzivateli
               MessageBeep(MB_ICONINFORMATION);
               MessageBoxA(Handle, "Instalace aplikace 'Vtipy verze 2.05' byla spn dokoena.",
                           "Hotovo...", MB_OK | MB_APPLMODAL | MB_ICONINFORMATION);
               break;
      case 2:  // Doslo k ukonceni zvenku
               // Nyni si pockame, az se thread ukonci
               WaitForSingleObject(hThread, INFINITE);
               // Zprava uzivateli
               MessageBeep(MB_ICONINFORMATION);
               MessageBoxA(Handle, "Instalace aplikace 'Vtipy verze 2.05' nebyla dokoena.",
                           "Pozor...", MB_OK | MB_APPLMODAL | MB_ICONINFORMATION);
               break;
      default: // V progress-threadu nastala chyba
               sprintf(lpText, "Instalace byla peruena, protoe v programu dolo\n"
                               "k neoekvan  vyjmce (slo %0.2u).  Vypnte prosm\n"
                               "vechny ostatn  programy,  spuste instalaci znovu\n"
                               "a pekontrolujte zadvan daje.\n", dwStopShadow);
               // Zprava uzivateli
               MessageBeep(MB_ICONSTOP);
               MessageBoxA(Handle, lpText, "Chyba...", MB_OK | MB_APPLMODAL | MB_ICONSTOP);
               break;
    } // Konec switch(dwStopShadow)
  } // Konec if(hThread)

  // Uvolneni kriticke sekce
  DeleteCriticalSection(&CritSec);

  // Zavreme handle na thread
  CloseHandle(hThread);

  // Konec aplikace
  InstallForm->Close();
}
//---------------------------------------------------------------------------


/* Tato funkce provede jako samostatny progress-thread instalaci,
   o prubehu bude informovat ProgressForm, ta pak informace zobrazi.
   Telo funkce se sklada ze 3 fazi:  I)   Kopirovani souboru
                                     II)  Zapis do registru
                                     III) Vytvoreni ikony na hlavni plose
 */

// Makra umoznujici pouzit polozky tridy ProgressForm bez
// uvedeni nazvu teto tridy.
#define fCreateShortcut     ProgressForm->fCreateShortcut
#define lpInstallDir        ProgressForm->lpInstallDir
#define lpInfoString        ProgressForm->lpInfoString
#define dwPercent           ProgressForm->dwPercent
#define dwStop              ProgressForm->dwStop
#define CritSec             ProgressForm->CritSec

DWORD WINAPI ProgressThreadFunction(LPVOID lpvThreadParam)
{
  // Zakladni promenne
  CHAR      lpBuffer[512];       // Pomocny buffer
  BOOL      fResult;             // Ukladani vysledku funkci
  DWORD     dwStopShadow;        // Stin synchronizovane promenne 'dwStop'
  CHAR      lpFirstFile[MAXPATH];// Jmeno a cesta souboru, ktery se zkopiroval jako prvni
  HKEY      hKey;                // Handle na klic v registru

  //
  //  *** Faze I) - Kopirovani souboru
  //

  // Promenne
  CHAR      lpSourceFile[512];   // Zdrojovy EXE soubor
  HANDLE    hSourceFile;         // Handle na zdrojovy EXE soubor
  HANDLE    hFile;               // Handle na cilovy soubor
  HANDLE    hFileMapping;        // Handle pametovyho mapovani
  LPVOID    lpvAddress;          // Adresa v zdrojovem EXE, ze ktere prave cteme
  LPVOID    lpvBaseAddress;      // Bazova adresa pohledu pametovyho mapovani
  DWORD     dwBytes = 0;         // Pomocne pocitadlo bytu

  // Promenne pro zjisteni dostatku mista na disku
  DWORD     dwClustersNeed;      // Kolik volnych clusteru je potreba pro instalaci
  DWORD     dwSecsPerClust;      // Kolik sektoru je na jeden cluster
  DWORD     dwBytesPerSec;       // Kolik bytu je na jeden sektor
  DWORD     dwNumOfFreeClusts;   // Pocet volnych clusteru
  DWORD     dwTotalNumOfClusts;  // Celkovy pocet clusteru
  CHAR      lpRootPathName[] = "X:\\"; // Root-dir disku, na ktery instalujeme
  CHAR      *lpRootPathNamePtr;  // Pomocny ukazatel na lpRootPathName

  // Promenne s informacemi o kopirovanych souborech
  #define NUMBER_OF_FILES           2
  DWORD    dwNumOfLinkFiles = NUMBER_OF_FILES;
  CHAR     lpNamesOfLinkFiles[NUMBER_OF_FILES][13] = { "Vtipy.exe", "Vtipy.dat" };
  DWORD    lpSizesOfLinkFiles[NUMBER_OF_FILES] = { 733184L, 7396L };
  DWORD    dwTotalSizeOfLinkFiles = 0;
  FILETIME FileTime[NUMBER_OF_FILES] = { { 0xDC9D0DE0L, 0x01BEF951L },
                                         { 0xDC9D0DE0L, 0xEA950151L } };

  // Zjistime celkovou velikost link-souboru
  for(DWORD i=0; i<NUMBER_OF_FILES; i++)
    dwTotalSizeOfLinkFiles += lpSizesOfLinkFiles[i];

  // Nyni zkontrolujeme, jestli je na disku dost mista

  // 1) Zjistime root-dir ciloveho disku (pokud znak 2 v retezci je ':',
  //    potom je pismeno disku ulozeno ve znaku cislo 1.)
  //    Ackoli promennou lpInstallDir pouzivaji oba thready, neni treba
  //    je synchronizovat, protoze 1. thread do ni zapisuje pouze jednou,
  //    a to v dobe, kdy ten 2. jeste neexistuje.
  if(lpInstallDir[1] == ':')
  {
    lpRootPathName[0] = lpInstallDir[0];
    lpRootPathNamePtr = lpRootPathName;
  }
  else
    lpRootPathNamePtr = NULL; // Pouzije se aktualni disk

  // 2) Zjisteni informaci o disku
  if(!GetDiskFreeSpace(lpRootPathNamePtr, &dwSecsPerClust, &dwBytesPerSec, &dwNumOfFreeClusts, &dwTotalNumOfClusts))
  {
    // Do dwStop ulozime kod chyby a ukocime thread
    EnterCriticalSection(&CritSec);
    dwStop = 3; // Kod vnitrni chyby threadu je 3
    LeaveCriticalSection(&CritSec);
    return(0); // Konec
  }

  // 3) Vypocet, kolik volnych clusteru potrebujeme
  dwClustersNeed = dwTotalSizeOfLinkFiles / (dwSecsPerClust * dwBytesPerSec) + NUMBER_OF_FILES;
  // Jeste pricteme 32 clusteru jako rezervu, protoze zapisy do registru
  // a adresare take zabiraji nejake misto.
  dwClustersNeed += 32;

  // 4) Porovnani volnych clusteru s nasi potrebou
  if(dwClustersNeed >= dwNumOfFreeClusts)
  { // Na disku je malo mista...
    // Do dwStop ulozime kod chyby a ukocime thread
    EnterCriticalSection(&CritSec);
    dwStop = 4; // Kod vnitrni chyby threadu je 4
    LeaveCriticalSection(&CritSec);
    return(0); // Konec
  }

  // --- Transfer informaci ----------------------------------------------------
  // Start kriticke sekce
  EnterCriticalSection(&CritSec);
  // Ulozeni dwStop
  dwStopShadow = dwStop;
  // Nastavime procenta
  dwPercent = 5; // % (celkem 5)
  // Zmenime label
  strcpy(lpInfoString, "Probh pprava...");
  // Konec kriticke sekce
  LeaveCriticalSection(&CritSec);
  // Neprisel z venku prikaz na ukonceni ?
  if(dwStopShadow)
    return(0);
  Sleep(275); // Predame zbytek CPU casu druhemu provadecimu toku
  // ---------------------------------------------------------------------------

  // Zjisteni nazvu a cesty zdrojoveho EXE souboru
  strcpy(lpSourceFile, _argv[0]);

  // Otevreni zdrojoveho EXE souboru
  hSourceFile = CreateFileA(lpSourceFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
  if(hSourceFile == INVALID_HANDLE_VALUE || hSourceFile == NULL)
  {
    // Do dwStop ulozime kod chyby a ukocime thread
    EnterCriticalSection(&CritSec);
    dwStop = 5; // Kod vnitrni chyby threadu je 5
    LeaveCriticalSection(&CritSec);
    return(0); // Konec
  }

  // Kontrola velikosti zdrojoveho souboru
  if(GetFileSize(hSourceFile, NULL) <= dwTotalSizeOfLinkFiles)
  {
    // Uklid
    CloseHandle(hSourceFile);
    // Do dwStop ulozime kod chyby a ukocime thread
    EnterCriticalSection(&CritSec);
    dwStop = 6; // Kod vnitrni chyby threadu je 6
    LeaveCriticalSection(&CritSec);
    return(0); // Konec
  }

  // Vytvorime pametovy mapovani toho souboru
  hFileMapping = CreateFileMapping(hSourceFile, NULL, PAGE_READONLY, 0, 0, NULL);
  if(hFileMapping==NULL)
  {
    // Uklid
    CloseHandle(hSourceFile);
    // Do dwStop ulozime kod chyby a ukocime thread
    EnterCriticalSection(&CritSec);
    dwStop = 7; // Kod vnitrni chyby threadu je 7
    LeaveCriticalSection(&CritSec);
    return(0); // Konec
  }

  // Udelame pametove-mapovany pohled na cely soubor
  lpvBaseAddress = lpvAddress = MapViewOfFile(hFileMapping, FILE_MAP_READ, 0, 0, 0);
  if(lpvAddress==NULL)
  {
    // Uklid
    CloseHandle(hFileMapping);
    CloseHandle(hSourceFile);

    // Do dwStop ulozime kod chyby a ukocime thread
    EnterCriticalSection(&CritSec);
    dwStop = 8; // Kod vnitrni chyby threadu je 8
    LeaveCriticalSection(&CritSec);
    return(0); // Konec
  }

  // --- Transfer informaci ----------------------------------------------------
  // Start kriticke sekce
  EnterCriticalSection(&CritSec);
  // Ulozeni dwStop
  dwStopShadow = dwStop;
  // Nastavime procenta
  dwPercent = 10; // %
  // Konec kriticke sekce
  LeaveCriticalSection(&CritSec);
  // Neprisel z venku prikaz na ukonceni ?
  if(dwStopShadow)
    return(0);
  Sleep(275); // Predame zbytek CPU casu druhemu provadecimu toku
  // ---------------------------------------------------------------------------

  // Posuneme adresu pred link-soubory
  lpvAddress = (LPVOID)((DWORD)lpvAddress + GetFileSize(hSourceFile, NULL) - dwTotalSizeOfLinkFiles);

  // Cteni a prepis souboru
  for(DWORD i=0; i<dwNumOfLinkFiles; i++)
  {
    // Priprava instalacni cesty - ackoli tuto promennou pouzivaji oba
    // thready, neni treba je synchronizovat, protoze 1. thread do ni
    // zapisuje pouze jednou, a to v dobe, kdy thread 2 jeste neexistuje.
    strcpy(lpBuffer, lpInstallDir);

    // Pridame backslash, pokud tam jeste neni.
    if(lpBuffer[strlen(lpBuffer)-1] != '\\')
      strcat(lpBuffer, "\\");

    // Ted pridame jmeno souboru
    strcat(lpBuffer, lpNamesOfLinkFiles[i]);

    // Nakopirujeme jmeno prvniho kopirovaneho souboru
    // i s cestou do lpFirstFile.
    if(i==0)
      strcpy(lpFirstFile, lpBuffer);

    // --- Transfer informaci ----------------------------------------------------
    // Start kriticke sekce
    EnterCriticalSection(&CritSec);
    // Ulozeni dwStop
    dwStopShadow = dwStop;
    // Nastavime procenta
    dwPercent += (WORD)(30 / dwNumOfLinkFiles); // % (celkem 10 - 60 ???)
    // Zmenime label
    sprintf(lpInfoString, "Kopruje se soubor '%0.13s'...", lpNamesOfLinkFiles[i]);
    // Konec kriticke sekce
    LeaveCriticalSection(&CritSec);
    // Neprisel z venku prikaz na ukonceni ?
    if(dwStopShadow)
      return(0);
    Sleep(275); // Predame zbytek CPU casu druhemu provadecimu toku
    // ---------------------------------------------------------------------------

    // Nyni otevreme (vytvorime) cilovy soubor
    hFile = CreateFileA(lpBuffer, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
    if(hFile == INVALID_HANDLE_VALUE || hFile == NULL)
    {
      // Uklid
      UnmapViewOfFile(lpvBaseAddress);
      CloseHandle(hFileMapping);
      CloseHandle(hSourceFile);

      // Do dwStop ulozime kod chyby a ukocime thread
      EnterCriticalSection(&CritSec);
      dwStop = 9; // Kod vnitrni chyby threadu je 9
      LeaveCriticalSection(&CritSec);
      return(0); // Konec
    }

    // Zapiseme do souboru
    fResult = WriteFile(hFile, lpvAddress, lpSizesOfLinkFiles[i], &dwBytes, NULL);
    if(!fResult || dwBytes == 0)
    {
      // Uklid
      UnmapViewOfFile(lpvBaseAddress);
      CloseHandle(hFileMapping);
      CloseHandle(hSourceFile);
      CloseHandle(hFile);

      // Do dwStop ulozime kod chyby a ukocime thread
      EnterCriticalSection(&CritSec);
      dwStop = 10; // Kod vnitrni chyby threadu je 10
      LeaveCriticalSection(&CritSec);
      return(0); // Konec
    }

    // Nastavime konec souboru
    SetEndOfFile(hFile);

    // Nastavime datum
    SetFileTime(hFile, &FileTime[i], &FileTime[i], &FileTime[i]);

    // A soubor zavreme
    CloseHandle(hFile);

    // Posun adresy na dalsi link soubor
    lpvAddress = (LPVOID)((DWORD)lpvAddress + lpSizesOfLinkFiles[i]);

    // --- Transfer informaci ----------------------------------------------------
    // Start kriticke sekce
    EnterCriticalSection(&CritSec);
    // Ulozeni dwStop
    dwStopShadow = dwStop;
    // Nastavime procenta
    dwPercent += (WORD)(20 / dwNumOfLinkFiles); // % (celkem max 60)
    // Zmenime label
    strcpy(lpInfoString, "Soubor zkoprovn...");
    // Konec kriticke sekce
    LeaveCriticalSection(&CritSec);
    // Neprisel z venku prikaz na ukonceni ?
    if(dwStopShadow)
      return(0);
    Sleep(275); // Predame zbytek CPU casu druhemu provadecimu toku
    // ---------------------------------------------------------------------------

  } // Konec kopirovaciho cyklu

  // Uklid
  UnmapViewOfFile(lpvBaseAddress);
  CloseHandle(hFileMapping);
  CloseHandle(hSourceFile);


  //
  //  *** Faze II - Zapis do registru
  //

  // --- Transfer informaci ----------------------------------------------------
  // Start kriticke sekce
  EnterCriticalSection(&CritSec);
  // Ulozeni dwStop
  dwStopShadow = dwStop;
  // Nastavime procenta
  dwPercent = 65; // %
  // Zmenime label
  strcpy(lpInfoString, "Zapisuji do registr...");
  // Konec kriticke sekce
  LeaveCriticalSection(&CritSec);
  // Neprisel z venku prikaz na ukonceni ?
  if(dwStopShadow)
    return(0);
  Sleep(275); // Predame zbytek CPU casu druhemu provadecimu toku
  // ---------------------------------------------------------------------------

  // Definice nazvu klicu a hodnot v registru
  #define   REG_SUBKEY1     "Software\\Jan Curn\\Vtipy\\02.05.00"
  #define   REG_SUBKEY2     "Software\\Microsoft\\Windows\\CurrentVersion\\Run"
  #define   REG_VALUENAME2  "Vtipy"
  #define   REG_SUBKEY3     "Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\Vtipy"
  #define   REG_VALUENAME31 "DisplayName"
  #define   REG_VALUENAME32 "UninstallString"

  // Promenne
  CHAR      lpUninstPath[MAXPATH]; // Prikaz, ktery provede odinstalaci (cesta k souboru VTIPY.EXE + "/UNINSTALL")

  // Vytvorime informacni klic v registru
  RegCreateKeyExA(HKEY_LOCAL_MACHINE, REG_SUBKEY1, NULL, NULL, REG_OPTION_NON_VOLATILE,
                  KEY_ALL_ACCESS, NULL, &hKey, NULL);
  // Zavreme klic
  RegCloseKey(hKey);

  // --- Transfer informaci ----------------------------------------------------
  // Start kriticke sekce
  EnterCriticalSection(&CritSec);
  // Ulozeni dwStop
  dwStopShadow = dwStop;
  // Nastavime procenta
  dwPercent = 70; // %
  // Konec kriticke sekce
  LeaveCriticalSection(&CritSec);
  // Neprisel z venku prikaz na ukonceni ?
  if(dwStopShadow)
    return(0);
  Sleep(275); // Predame zbytek CPU casu druhemu provadecimu toku
  // ---------------------------------------------------------------------------

  // Otevreme klic obsahujici jmena programu pro spusteni pri kazdem
  // restartu pocitace a ulozime tam lpFirstFile ("Vtipy.exe")
  if(RegCreateKeyExA(HKEY_LOCAL_MACHINE, REG_SUBKEY2, NULL, NULL, REG_OPTION_NON_VOLATILE,
                     KEY_SET_VALUE, NULL, &hKey, NULL) == ERROR_SUCCESS)
  {
    // Do hodnoty "Vtipy" ulozime prvni kopirovany soubor - "Vtipy.exe",
    // aby se spoustel pri kazdem restartu.
    RegSetValueExA(hKey, REG_VALUENAME2, 0, REG_SZ, (LPBYTE)lpFirstFile, MAXPATH);

    // Zavreme klic
    RegCloseKey(hKey);
  }

  // --- Transfer informaci ----------------------------------------------------
  // Start kriticke sekce
  EnterCriticalSection(&CritSec);
  // Ulozeni dwStop
  dwStopShadow = dwStop;
  // Nastavime procenta
  dwPercent = 80; // %
  // Konec kriticke sekce
  LeaveCriticalSection(&CritSec);
  // Neprisel z venku prikaz na ukonceni ?
  if(dwStopShadow)
    return(0);
  Sleep(275); // Predame zbytek CPU casu druhemu provadecimu toku
  // ---------------------------------------------------------------------------

  // Nyni otevreme klic obsahujici informace o odinstalaci programu
  if(RegCreateKeyExA(HKEY_LOCAL_MACHINE, REG_SUBKEY3, NULL, NULL, REG_OPTION_NON_VOLATILE,
                     KEY_WRITE, NULL, &hKey, NULL) == ERROR_SUCCESS)
  {
    // Zjisteni jmena a cesty prvniho kopirovaneho souboru - "Vtipy.exe"
    strcpy(lpUninstPath, lpFirstFile);
    // Pridani prepinace spoustejiciho odinstalaci
    strcat(lpUninstPath, " /UNINSTALL");

    // Ulozeni hodnot
    RegSetValueExA(hKey, REG_VALUENAME31, 0, REG_SZ, (LPBYTE)"Vtipy verze 2.05", MAXPATH);
    RegSetValueExA(hKey, REG_VALUENAME32, 0, REG_SZ, (LPBYTE)lpUninstPath, MAXPATH);

    // Zavreme klic
    RegCloseKey(hKey);
  }

  //
  //  *** Faze III - Vytvoreni ikony na hlavni plose
  //

  // Promenne
  CHAR      lpDesktopPath[MAXPATH];     // Cesta k adresari DESKTOP
  DWORD     dwDesktopPathSize;          // Velikost cesty ve znacich

  // Mame skutecne vytvorit ikonu na hlavni plose ???
  if(fCreateShortcut)
  {
    // --- Transfer informaci ----------------------------------------------------
    // Start kriticke sekce
    EnterCriticalSection(&CritSec);
    // Ulozeni dwStop
    dwStopShadow = dwStop;
    // Nastavime procenta
    dwPercent = 90; // %
    // Uprava labelu
    strcpy(lpInfoString, "Vytv se ikona na hlavn ploe...");
    // Konec kriticke sekce
    LeaveCriticalSection(&CritSec);
    // Neprisel z venku prikaz na ukonceni ?
    if(dwStopShadow)
      return(0);
    Sleep(275); // Predame zbytek CPU casu druhemu provadecimu toku
    // ---------------------------------------------------------------------------

    // Zjistime pozici slozky DESKTOP (ve WIN9x CZ standartne C:\WINDOWS\PLOCHA),
    // ta je ulozena v registru (hodnota HKEY_CURRENT_USER\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\Desktop)
    #define REG_SHELL_FOLDERS_SUBKEY    "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders"
    #define REG_DESKTOP_VALUE_NAME      "Desktop"

    // Otevreme dany klic
    if(RegOpenKeyEx(HKEY_CURRENT_USER, REG_SHELL_FOLDERS_SUBKEY, 0, KEY_READ, &hKey)
       == ERROR_SUCCESS)
    {
      // Inicializace lpDesktopPath a dwDesktopPathSize
      ZeroMemory(lpDesktopPath, sizeof(lpDesktopPath));
      dwDesktopPathSize = MAXPATH;

      // Zjisteni hodnoty
      RegQueryValueExA(hKey, REG_DESKTOP_VALUE_NAME, NULL, NULL, (LPBYTE)lpDesktopPath, &dwDesktopPathSize);

      // Kontrola ziskanych dat
      if(strlen(lpDesktopPath))
      {
        // K ceste pridame jeste jmeno linku ("Vtipy...")
        strcat(lpDesktopPath, "\\Vtipy....lnk");

        // Inicializujeme Component Object Library
        CoInitialize(NULL);

        // A konecne cely link (ikonu) vytvorime
        CreateLink(lpFirstFile, lpDesktopPath, "Vtipy verze 2.05 Freeware, by Jan urn.");

        // Deinicializace Component Object Library
        CoUninitialize();
      } // Konec if(...)

      // Zavreme klic
      RegCloseKey(hKey);
    } // Konec if(RegOpenKeyExA(...) == ERROR_SUCCESS)
  } // Konec if(fCreateShortcut)

  // --- Transfer informaci ----------------------------------------------------
  // Start kriticke sekce
  EnterCriticalSection(&CritSec);
  // Ulozime, ze instalace uz byla dokoncena
  dwStop = 1;
  // Nastavime procenta
  dwPercent = 100; // %
  // Uprava labelu
  strcpy(lpInfoString, "Hotovo...");
  // Konec kriticke sekce
  LeaveCriticalSection(&CritSec);
  // ---------------------------------------------------------------------------

  // A Konecne ukoncime Progress-thread
  // Instalace probehla OK...
  return(0);

} // Konec ProgressThreadFunction()
