//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
#include "Main.h"
#include "Help.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
// Konstruktor - provede inicializaci
__fastcall TMainForm::TMainForm(TComponent* Owner) : TForm(Owner)
{
  
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CreateParams(Controls::TCreateParams &Param)
{
  TForm::CreateParams(Param);
  Param.Style = WS_POPUP | WS_BORDER; // Okno bude bez titulkoveho pruhu a systemoveho menu
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  // Pomocny buffer
  CHAR  lpBuffer[16];

  // Inicializace MCRNG
  randomize();

  // Zjistime jmeno a cestu k souboru "Vtipy.dat"
  strcpy(lpFileName, _argv[0]);
  strcpy(strrchr(lpFileName, '\\') + 1, FILENAME);

  // Uzivatel jeste neudelal zadnou akci
  fAction = FALSE;

  // Jeste nemame zadny vtip
  ZeroMemory(lpJokeText, sizeof(lpJokeText));

  // Inicializace pole 'Pictures' pro nahravani obrazku z resource (viz. Resource.h)
  for(DWORD i=0; i<NUM_OF_PICTURES; i++)
  {
    // Vytvorime jmena souboru s obrazky podle jejich indexu (PICTURE00, PICTURE01, ...)
    sprintf(lpBuffer, "PICTURE%0.2u", i);
    asPictures[i] = lpBuffer;
  }

  // Pokud od startu pocitace uplynulo aspon 25 sekund, neni to restart.
  fRestart = (GetTickCount() > 25000) ? false : true;

  // Zjistime, jestli se nyni Vtipy spousteji pri kazdem restartu

  // Otevreni klice registru s programy spoustenymi pri kazdem startu
  lRetValue = RegOpenKeyExA(HKEY_LOCAL_MACHINE, REG_SUBKEY, 0, KEY_ALL_ACCESS, &hKey);

  // Podarilo se klic otevrit ?
  if(lRetValue == ERROR_SUCCESS)
  {
    // Pomocne promenne
    DWORD     dwSize = MAXPATH;   // Velikost buffer
    CHAR      lpBuffer[MAXPATH];  // Pomocny buffer

    // Inicializace bufferu
    ZeroMemory(lpBuffer, MAXPATH);

    // Nacteme textu hodnoty "Vtipy", pokud ovsem existuje
    RegQueryValueExA(hKey, REG_VALUENAME, NULL, NULL, (LPBYTE)lpBuffer, &dwSize);

    // Porovnani textu se jmenem tohoto souboru, pokud je stejny,
    // vtipy se spousteji pri restaru, pokud ne, tak ne.
    if(!strcmpi(_argv[0], lpBuffer))
      RestartCheckBox->Checked = true;  // Vtipy se spousteji pri restartu
    else
      RestartCheckBox->Checked = false; // Vtipy se nespousteji pri restartu
  }

  // Zobrazeni nahodne bitmapy pres cele okno
  Obrazek->Picture->Bitmap->LoadFromResourceName(int(HInstance), asPictures[rand() % NUM_OF_PICTURES]);

  // Inicializace tridy QJokes
  if(jJokes.Initialize(lpFileName))
  {
    if(jJokes.GetRandomJoke(lpJokeText, MAXPATH))
      Text->Caption = lpJokeText;
    else // Nastala chyba, tak ji zobrazime misto vtipu
      Text->Caption = jJokes.lpBuffer;
  }
  else // Nastala chyba pri inicializaci, zobrazime ji
    Text->Caption = jJokes.lpBuffer;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
  // Do registru ulozime, jestli se maj vtipy spoustet pri restartu,
  // to nam urcil uzivatel v CheckBoxu.
  if(lRetValue == ERROR_SUCCESS)
  {
    if(RestartCheckBox->Checked)
      RegSetValueExA(hKey, REG_VALUENAME, 0, REG_SZ, (LPBYTE)_argv[0], MAXPATH);
    else
      RegDeleteValueA(hKey, REG_VALUENAME);
    // Zavreme klic
    RegCloseKey(hKey);
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::HelpButtonClick(TObject *Sender)
{
  // Jedna se o uzivatelskou akci
  fAction = true;

  // Tlacitko Help spusti informace
  HelpForm->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TimerTimer(TObject *Sender)
{
  // Jestlize po 15 sekundach od spusteni Vtipu uzivatel nic neudelal a
  // pritom se jedna o spusteni po restartu pocitace, ukoncime program.
  Timer->Enabled = false;
  if(!fAction && fRestart)
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EndButtonClick(TObject *Sender)
{
  // Tlacitko End ukonci program
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::NextButtonClick(TObject *Sender)
{
  // Jedna se o uzivatelskou akci
  fAction = true;

  // Tlacitko Next zmeni vtip
  if(jJokes.GetRandomJoke(lpJokeText, MAXPATH))
    Text->Caption = lpJokeText;
  else // Nastala chyba, tak ji zobrazime
    Text->Caption = jJokes.lpBuffer;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ObrazekClick(TObject *Sender)
{
  // Kliknuti na obrazek znamena uzivatelskou akci
  fAction = true;
}
//---------------------------------------------------------------------------
